/************************************************************************
* Copyright (c) 1995 Valentin Shopov, Blagoevgrad, Bulgaria		*
*									*
* Permission to use, copy, modify, and distribute this material for any	*
* purpose and without fee is hereby granted, provided that the above	*
* copyright notice and this permission notice appear in all copies, and	*
* that the name of the author not be used in advertising or publicity 	*
* pertaining to this material without the specific, prior written 	*
* permission of the author.						*
*									*
* THE AUTHOR MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY	*  
* OF THIS MATERIAL FOR ANY PURPOSE. IT IS PROVIDED "AS IS", WITHOUT ANY	* 
* EXPRESS OR IMPLIED WARRANTIES.					*
*************************************************************************/

/**************************ciilib1.0.3***********************************
 *									*
 *        Character to Inline Image Conversion Library (CIILIB)		*
 *									*
 *	Encoder for Character by Inline Image of HTML on HTTP		*
 *			by Valentin Shopov				*
 *			valentin@rs.aubg.bg				*
 ************************************************************************/

#include <stdio.h>
/*
int CII_isPRE;
*/
static int isTag, isTitle;
extern char *chsetabbr[];
extern char D_CHARSET[];
extern int numof256c;

static int is256c()
{int convnum,i;
        if(numof256c && !strncmp(D_CHARSET,"II@",3)){
        convnum=0;
        for(i=0;chsetabbr[i];i++){
                if(!strcmp(D_CHARSET+3,chsetabbr[i])){
                        convnum=i;
                        break;
                }
        }
	}
        else convnum=-1;
        return(convnum);
}

unsigned char *
EUC_TO_CII(src,dst,ctype,ubase)
unsigned char *src, *dst;
char *ctype,*ubase;
{	register unsigned char *sp,*dp;
	int isPlain,cs256;

	isPlain = strcasecmp(ctype,"text/plain") == 0;

	for(sp=src, dp=dst; *sp; ){
/*
	if(CII_isPRE>0 && isPlain){
	sprintf(dp,"<PRE>");
	dp+=5;
	CII_isPRE=-1;
	}
*/
	if(*sp == '<' && !isTag && !isPlain){
		isTag=1;
		if(!isTitle && !strncmp(sp,"<TITLE>",7)) isTitle = 1;
		else
		if(isTitle && !strncmp(sp,"</TITLE>",8)) isTitle = 0;
	}
	if(isTag || isTitle){
		if(*sp == '>' && isTag) isTag = 0;
		*dp++ = *sp++;
	}
	else{



		if( *sp & 0x80 ){
			if((cs256=is256c())!=-1){
			 sprintf(dp,"<IMG SRC=\"%s%02x%02x\">",ubase,cs256,sp[0]);
		       	 dp += strlen(dp); sp++; 
			}
			else {
			if(sp[1] & 0x80){
				sprintf(dp,"<IMG SRC=\"%s%x%x\">",ubase,sp[0],sp[1]);
				dp += strlen(dp); sp += 2;
			}else	sp++;
			}
		}else{	if(isPlain){ switch(*sp) {
				case '<' : 
					sprintf(dp,"&lt;");
					dp += 4; sp++;
					break;
				case '>' : 
					sprintf(dp,"&gt;");
					dp += 4; sp++;
					break;
				case '&' : 
					sprintf(dp,"&amp;");
					dp += 5; sp++;
					break;
				case '"' : 
					sprintf(dp,"&quot;");
					dp += 6; sp++;
					break;
				default:
					*dp++ = *sp++;
					break;
				    }
			}else *dp++ = *sp++;
		}
	}
	}
	*dp = 0;
	return dst;
}
TO_CII(any,gr,ctype,ubase)
	unsigned char *any,*gr;
	char *ctype,*ubase;
{	char *euc,*iifl;
	int i;
        if(is256c()!=-1) EUC_TO_CII(any,gr,ctype,ubase);
	else{
	euc = (char*)malloc(strlen(any)+1);
	TO_EUC(any,euc);
	EUC_TO_CII(euc,gr,ctype,ubase);
	free(euc);
	}
}

extern char *xbmsrc[];
extern int xbmind[];
static char xbmbuf[500];
static char *getCII(name)
	char *name;
{	int i,euc,kanind;
	char *gkand,*curxbm;
	gkand = xbmbuf;
	sscanf(name,"%x",&euc);
	kanind=(euc/256-161)*94 + euc%256-161;
	if(xbmind[kanind] == -1) return 0;
	curxbm = xbmsrc[xbmind[kanind]];
	sprintf(gkand,"#define %s_width 16\n#define %s_height 16\nstatic char %s_bits[] = {\n\0",name,name,name);
	for(i = 0; i< 32; i++) {
	sprintf(gkand+strlen(gkand),"0x%02x,\0",(unsigned char)curxbm[i]);
	}
	sprintf(gkand+strlen(gkand)-1,"};\n\0");
	return gkand;
}

extern char *xbmsrc_256[][257];
extern int xbmind_256[][257];
static char *getCII_256(name)
        char *name;
{       int i,code,cindr,cindc;
        char *gchd,*curxbm;
        gchd = xbmbuf;
        sscanf(name,"%x",&code);
        cindr=code/256; cindc=code%256; 
	if(cindr>numof256c || xbmind_256[cindr][cindc] == -1) return 0;
        curxbm = xbmsrc_256[cindr][xbmind_256[cindr][cindc]];
        sprintf(gchd,"#define %s_width 8\n#define %s_height 16\nstatic char %s_bits[] = {\n\0",name,name,name);
        for(i = 0; i< 16; i++) {
        sprintf(gchd+strlen(gchd),"0x%02x,\0",(unsigned char)curxbm[i]);
        }
        sprintf(gchd+strlen(gchd)-1,"};\n\0");
        return gchd;
}


putCII(tc,vno,gkan)
	FILE *tc;
	char *gkan;
{	char *data,*getCII(),*getCII_256();
	int size;
	int leng = 0;

	if( (data = (is256c()==-1)?getCII(gkan):getCII_256(gkan)) == 0 )
		return 0;
	size = strlen(data);
	leng += HTTP_putHeader(tc,vno,"image/x-xbitmap",size);
	leng += fwrite(data,1,size,tc);
	return leng;
}

